using System;
using ProtoBuf;
using Fantasy;
using System.Linq;
using System.Reflection;
using System.Collections.Generic;
using System.Collections.Concurrent;
using Fantasy.Serialize;
using Fantasy.ConfigTable;

namespace NBF
{
    [ProtoContract]
    public sealed partial class RingConfig : ASerialize, IProto, IConfigTable
    {
    
		[ProtoMember(1)]
		public uint Id { get; set; } // Id
		[ProtoMember(2)]
		public string Model { get; set; } // 模型  
        [ProtoIgnore]
        public uint Key => Id;
        
        #region Static
        
        private static ConfigContext<RingConfig> Context => ConfigTableHelper.Table<RingConfig>();

        public static RingConfig Get(uint key)
        {
            return Context.Get(key);
        }

        public static RingConfig Get(Predicate<RingConfig> match)
        {
            return Context.Get(match);
        }
        
        public static RingConfig Fist()
        {
            return Context.Fist();
        }

        public static RingConfig Last()
        {
            return Context.Last();
        }

        public static RingConfig Fist(Predicate<RingConfig> match)
        {
            return Context.Fist(match);
        }

        public static RingConfig Last(Predicate<RingConfig> match)
        {
            return Context.Last(match);
        }
        
        public static int Count()
        {
            return Context.Count();
        }

        public static int Count(Func<RingConfig, bool> predicate)
        {
            return Context.Count(predicate);
        }

        public static List<RingConfig> GetList()
        {
            return Context.GetList();
        }

        public static List<RingConfig> GetList(Predicate<RingConfig> match)
        {
            return Context.GetList(match);
        }
        public static void ParseJson(Newtonsoft.Json.Linq.JArray arr)
        {
            ConfigTableHelper.ParseLine<RingConfig>(arr);
        }
        #endregion
    }
}